/*
 * qml.h
 *
 *
 * declaration of all shared functions and variables of qml.c
 *
 * by Korbinian Strimmer and Arndt von Haeseler (1995)
 * this file belongs to the Puzzle version 2.3 distribution 
 *
 */


EXTERN char **Identif;   /* species names */
EXTERN char **Seqchar;   /* sequence data */
EXTERN double *Freqext;  /* external base frequencies for use in the ML       */
EXTERN double *Freqtpm;  /* base frequencies that are really used in the ML   */
EXTERN double AlphaBeta; /* Ts rate / Tv rate ratio                           */
EXTERN double AlphaYR;   /* Y transition / R transition rate                  */
EXTERN int Converg;      /* flag for ML convergence                           */
EXTERN int data_optn;    /* type of sequnce input data                        */  
EXTERN int Dayhf_optn;   /* Dayhoff model                                     */
EXTERN int Frequ_optn;   /* use empirical frequencies when computing ML       */
EXTERN int Jtt_optn;     /* JTT model                                         */
EXTERN int Maxseqc;      /* number of sequence characters per taxum           */
EXTERN int Maxsite;      /* number of ML characters per sequence              */
EXTERN int Maxspc;       /* number of sequences in the infile                 */
EXTERN int mtrev_optn;   /* mtREV model                                       */
EXTERN int nuc_optn;     /* nucleotide (4x4) models                           */
EXTERN int Numit;        /* number of ML iterations if there is convergence   */
EXTERN int SH_optn;      /* SH nucleotide (16x16) model                       */
EXTERN int sym_optn;     /* symmetrize doublet frequencies                    */

char *int2code(int s);                             /* state -> code           */
double quartet_alklhd(int a, int b, int c, int d); /* compute approximate ML  */
double quartet_lklhd(int a, int b, int c, int d);  /* compute ML (a,b)-(c,d)  */
int code2int(cvector c);                           /* code -> state           */
int getcodelength();                               /* length of code          */
int gettpmradix();                                 /* number of states        */
int isacid(char c);                                /* check for allowed chars */
void qmlfinish();                                  /* finish ML analysis      */
void qmlstart();                                   /* start ML analysis       */
